#include "opencv2/highgui.hpp"
#include "opencv2/core.hpp"
#include "opencv2/imgproc.hpp"
#include <iostream>
#include <json/json.h>
#include <fstream>
#include <filesystem>
#include "pointbase.cpp"


using namespace cv;
using namespace std;
namespace fs = std::filesystem;

//C++17
//sudo apt install libjsoncpp-dev
//sudo ln -s /usr/include/jsoncpp/json/ /usr/include/json
int main(int argc, char** argv)
{
    /* //print point values manually
    std::string path = "../data/";
    for (const auto & entry : fs::directory_iterator(path))
        {
            string filePath = entry.path();
            //cout << filePath.find(".json") << std::endl;
            if (filePath.find(".json") != string::npos) 
            {
                std::cout << filePath << std::endl;
                std::ifstream coord_file(filePath, std::ifstream::binary);
                Json::Value coords;

                coord_file >> coords;
                cout << "x: " << coords["depthPos"]["x"].asDouble() << std::endl;
                cout << "y: " << coords["depthPos"]["y"].asDouble() << std::endl;
            }

        }
    */

    //test pointbase load
    PointBase pb;
    //pb.load("../data/");
    //120/2022-11-15_09-35-09
    //155/2022-11-15_07-18-56
    //2/2022-10-13_13-33-22
    //1/2022-10-13_11-50-12
    //pb.load("../1/2022-10-13_11-50-12/snapshots/");
    pb.load("../data/");

    //test print all point info
    pb.printPoints(0);

    /* test get path
    path: ../data/0000044.json; 
    x: 206.5; 
    y: 1051; 
    */
    cout << pb.getPath(206.500,1051.00) << '\n';

    pb.showPointImg();

    /*
    vector<Point2d> res = pb.getAdjacents(Point2d(75.1,3220.80));
    for (Point2d p :res)
    {
        cout << "x: " << p.x << std::endl;
        cout << "y: " << p.y << std::endl;
    }
    */

    //pb.stitchImgs();
    cout <<"IMG HEIGHT:" << pb.imgHeightDeg <<"\n";
    cout <<"IMG WIDTH DEG:" << pb.imgWidthDeg <<"\n";
    pb.cumdump(650,525);

}